



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>0070 过滤器调用Spring的bean操作数据库</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">0070 过滤器调用Spring的bean操作数据库</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-25 08:06:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>假设有这样的需求：将用户每次请求的ip、时间、请求、user-agent存入数据库，很明显可以用过滤器实现，在过滤器中获取到这些数据调用mybatis的mapper存入数据库，但问题来了：mybatis的映射接口规则自动生成的Dao实现类存在于Spring容器中，在filter中如何才能注入或者调用呢？</p>
<p>首先是web.xml配置</p>
<pre class="prettyprint linenums"><code>	&lt;filter&gt;<br />
		&lt;!-- 注意下面这个过滤器名称要跟下面的spring-context.xml的相同 --&gt;<br />
        &lt;filter-name&gt;myRequestLogFilter&lt;/filter-name&gt;<br />
        &lt;filter-class&gt;org.springframework.web.filter.DelegatingFilterProxy&lt;/filter-class&gt;<br />
        &lt;init-param&gt;<br />
            &lt;param-name&gt;targetFilterLifecycle&lt;/param-name&gt;<br />
            &lt;param-value&gt;true&lt;/param-value&gt;<br />
        &lt;/init-param&gt;<br />
    &lt;/filter&gt;<br />
    &lt;filter-mapping&gt;<br />
        &lt;filter-name&gt;myRequestLogFilter&lt;/filter-name&gt;<br />
        &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
    &lt;/filter-mapping&gt;<br />
</code></pre>
<p>写filter</p>
<pre class="prettyprint linenums"><code>package net.sonngdemo.wms.util;

import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.*;<br />
import java.io.IOException;

/**<br />
 * Created by Administrator on 2017/7/3.<br />
 */

public class ReqeustFilter implements Filter {

    @Autowired<br />
    private RequestFilterInSpring requestFilterInSpring; /*注入下面的Spring容器中的bean，实现了具体的过滤器方法*/

    @Override<br />
    public void init(FilterConfig filterConfig) throws ServletException {<br />
    }

    @Override<br />
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {<br />
        requestFilterInSpring.filter(request,response);  //具体的过滤规则写在下面一个类中<br />
        chain.doFilter(request,response);<br />
    }

    @Override<br />
    public void destroy() {

    }<br />
}

</code></pre>
<p>配置Spring-context.xml</p>
<pre class="prettyprint linenums"><code>&lt;bean name=&quot;myRequestLogFilter&quot; class=&quot;net.sonngdemo.wms.util.ReqeustFilter&quot; &gt;&lt;/bean&gt;<br />
&lt;!-- 注意这个bean的name要跟上面的web.xml中的名称相同 --&gt;<br />
</code></pre>
<p>写一个Spring Bean，具体实现过滤器方法</p>
<pre class="prettyprint linenums"><code>package net.sonngdemo.wms.util;

import net.sonngdemo.wms.dao.RequestLogMapper;<br />
import net.sonngdemo.wms.domain.RequestLog;<br />
import org.springframework.beans.factory.annotation.Autowired;<br />
import org.springframework.stereotype.Component;

import javax.servlet.ServletRequest;<br />
import javax.servlet.ServletResponse;<br />
import javax.servlet.http.HttpServletRequest;<br />
import java.util.Date;

/**<br />
 * Created by Administrator on 2017/7/3.<br />
 */<br />
@Component(&quot;requestFilterInSpring&quot;)  /*注意名称跟上面过滤器中注入的名称相同*/<br />
public class RequestFilterInSpring {<br />
    @Autowired<br />
    private RequestLogMapper requestLogMapper; /*注入mapper实现类*/

    public void filter(ServletRequest request,ServletResponse response){ /*具体实现过滤器方法*/<br />
        HttpServletRequest httpRequest=(HttpServletRequest)request;<br />
        String uri=httpRequest.getRequestURI();<br />
        String regex = &quot;/wms/(css|errorPage|fonts|js|media)/.*&quot;;<br />
        if (!uri.matches(regex)) {<br />
            RequestLog requestLog=new RequestLog();<br />
            requestLog.setIp(request.getRemoteHost());<br />
            requestLog.setDate(new Date());<br />
            requestLog.setRequest(uri);<br />
            requestLog.setUserAgent(httpRequest.getHeader(&quot;user-agent&quot;));<br />
            requestLogMapper.insertLog(requestLog);<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>其他mapper略</p>
<p>总结：</p>
<ol><li>web.xml中配置一个过滤器代理</li>
<li>写一个过滤器实现Filter接口，通过调用Spring容器中的bean来实现过滤方法</li>
<li>在Spring配置文件中，创建该过滤器的bean对象，注意该该bean的名称要跟web.xml中的名称相同</li>
<li>写一个bean，具体实现过滤方法，用@component注解</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mnedoq.html">iOS提交AppStore后申请加急审核</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q25v7vq.html">iOS开发之多表视图滑动切换示例（仿&amp;quot&semi;头条&amp;quot&semi;客户端）---优化篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2xgol9.html">win7无法保存打印机设置&lpar;错误0x000006d9&rpar;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96466j8.html">Oracle中修改表名遇到&OpenCurlyDoubleQuote;ORA-00054&colon; 资源正忙&comma; 但指定以 NOWAIT 方式获取资源&comma; 或者超时失效&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxno4oz8.html">第三百三十一天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd051e8.html">c&num; 计算两日期的工作时间间隔&lpar;排除非工作日&rpar;及计算下一个工作时间点&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydr4vgq.html">iOS  关于流媒体 的初级认识与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ddmj9.html">前台页面Josn 数组在后台&period;cs代码中的解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn360v8.html">javascript动态改变当前页面中元素的状态行为</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m51peq.html">java -jar start&period;jar和nohup java -jar xxx&period;jar &amp;gt&semi; test&period;log &amp;amp&semi;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjloj49.html">Hdu3640-I&comma; zombie&lpar;模拟&plus;二分&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z32z09.html">11&rpar; 十分钟学会android--Intent消息处理与传递详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp33xjq.html">关于tween&period;js测试介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jev1l8.html">unity A&ast;寻路 （三）A&ast;算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgod6r8.html">Golang 入门系列（八） cron定时任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0pmz8.html">js一些代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rm4w28.html">rsyslog&plus;loganalyzer配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv22dnz9.html">Promise实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wpd1rq.html">Kotlin的参考资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e455dm9.html">实战Google深度学习框架-C5-MNIST数字识别问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2kryrxq.html">Spark Streaming中空batches处理的两种方法（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emdxlj9.html">nmap常用扫描命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2krnm3q.html">Eclipse 构建Maven项目--普通web项目 复制另外一个项目的配置文件导致的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl6p4y9.html">hihoCoder 1261 String Problem II</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkmp538.html">easyui datagrid 分页保持checkbox选中状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/902o5p3q.html">&amp;lt&semi;The Art of Readable Code&amp;gt&semi; 笔记二 &lpar;上&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emdgyx9.html">Android DataBinding库&lpar;MVVM设计模式&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvp7vgq.html">关于ActiveMQ的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e45219.html">Cg入门21：Fragment shader - 2D纹理採样</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppz41y9.html">JSP生成静态html网页</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
